package com.logicbig.example;

import org.springframework.beans.BeanUtils;
import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;

public class ResolveSignature {

    public static void main(String[] args) throws
            InvocationTargetException, IllegalAccessException {
        Method method = BeanUtils.resolveSignature("aMethod(java.lang.String, int)", LocalBean.class);
        System.out.println("resolved method: " + method);
        method.invoke(new LocalBean(), "some string value", 100);

        method = BeanUtils.resolveSignature("aMethod(java.lang.Integer)", LocalBean.class);
        System.out.println("resolved method: " + method);
        method.invoke(new LocalBean(), 200);
    }

    private static class LocalBean {
        public void aMethod(String str, int anInt) {
            System.out.printf("aMethod invoked with params, str: %s, anInt: %s%n", str, anInt);
        }

        public void aMethod(Integer anInt) {
            System.out.printf("aMethod invoked with param, anInt: %s%n", anInt);
        }
    }
}